structure BM4 = Matrix(structure R = Boole; 
                       val rows = 4; val cols = 4);

val E = BM4.tabulate 
  (fn (0,0) => 0 | (0,1) => 0 | (0,2) => 1 | (0,3) => 0
    | (1,0) => 0 | (1,1) => 0 | (1,2) => 0 | (1,3) => 1
    | (2,0) => 0 | (2,1) => 0 | (2,2) => 0 | (2,3) => 1
    | (3,0) => 1 | (3,1) => 0 | (3,2) => 0 | (3,3) => 0);

fun wege A n = if n = 1 then A else 
    let 
        val B = wege A (n-1) 
    in 
        BM4.sum(B, BM4.prod(B, A)) 
    end;

fun tc A = wege A 4;
